# Workflow Picker
# 2014-05-13 by Derick Fay
#
# built with Dean Jackson's Workflow Library
# http://www.deanishe.net/alfred-workflow/index.html
#
# partly based on Shawn Patrick Rice's help workflow
# https://github.com/shawnrice/alfred2-workflow-help/blob/master/help.py
#


import sys
import os
from workflow import Workflow
from plistlib import *

def main(wf):

# Get query from Alfred
	if len(wf.args):
		query = wf.args[0]
	else:
		query = None

	# Get list of locations of workflow plists
	listdir = os.path.dirname(os.getcwd())
	dirs = os.walk(listdir).next()[1]
	results = []

	for folder in dirs:
		try:
			plistFile = listdir + "/" + folder + "/info.plist" # find the plist file
			try:
				iconFile = listdir + "/" + folder + "/icon.png"
			except:
				'icon missing'
			pl = readPlist(plistFile)
			if ('category' in pl):
				if (pl['category']==query) or (query=='All'):
					source=pl['name']
					if "objects" in pl:
						for item in pl['objects']:
							if (item['type'] == "alfred.workflow.input.keyword"):	
								if "keyword" in item['config']:
									results=results+[{'title':item['config']['keyword'],'subtitle':item['config']['text'],'valid':True,'arg':item['config']['keyword'],'icon':iconFile,'source':source}]
							if (item['type'] == "alfred.workflow.input.scriptfilter"):	
								if "keyword" in item['config']:
									results=results+[{'title':item['config']['keyword'],'subtitle':item['config']['title'],'valid':True,'arg':item['config']['keyword'],'icon':iconFile,'source':source}]
		except:
			'plist file missing'
		# creating a dictionary of results allows us to sort before population the workflow results
		# sort by keyword:
		# results = sorted (results, key = lambda item:item['title'])
		# group by source workflow:
	results = sorted (results, key = lambda item:item['source'])		
		
	for r in results:
			wf.add_item(title=r['title'],
 						subtitle=r['subtitle']+' (from '+r['source']+')',
 						valid=r['valid'],
 						arg=r['arg'],
 						icon=r['icon'])
	wf.send_feedback()
if __name__ == u"__main__":
	wf = Workflow()
	sys.exit(wf.run(main))
	
# to do:
# handle hotkeys
# figure out how to exclude workflows that are not enabled